#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/*
Compilation instructions

make

This programm compute the files const32.c and const64.c
*/

#define NBROUND 256  
#define K 128 

#define ENTREE 1024 
#define SORTIE 256
#ifdef M64
#define COMP 64
#else
#define COMP  32
#endif

#if (COMP==64)
typedef unsigned long long BlockType;
#define NE 16
#define NS 4
#define NPM 8

#endif

#if (COMP==32)
typedef unsigned int BlockType;
#define NE 32
#define NS 8
#define NPM 4

#endif

#define NA 256
#define NBE 8




FILE *resultats;

 BlockType nbalea[2*NE*NA*16+NE-(128/NE)];


#if (COMP==64)
BlockType nb_hasard(int a) {
	double f;
	BlockType sortie;
        f=sin(a+1);
        if (f<0) {f=-f;}
	f=f*8;
	f=f-floor(f);
        f=f*(1UL<<32);
	sortie=((BlockType)floor(f))<<32;
        f=sin(a+2);
        if (f<0) {f=-f;}
	f=f*8;
	f=f-floor(f);
        f=f*(1UL<<32);
	sortie|=(BlockType)floor(f);
        return(sortie);
}
#endif
#if (COMP==32)
/*Constants K_i */
BlockType nb_hasard(int a) {
	double f;
        f=sin(a+1);
        if (f<0) {f=-f;}
	f=f*8;
	f=f-floor(f);
        f=f*(1UL<<31)*2;
        return(floor(f));
}
#endif

void init_alea() {
    int i,nor,nof,part,a,place,pos,bloc;
    BlockType x;

//First we calculate the K_i constant for i<0. These constant are used by the function g_j with j>16.
//There is no need of a mask
#if (COMP==64)
    for(a=0;a<NE-2;a++) {
                x=nb_hasard(2*a);
#endif
#if (COMP==32)
    for(a=0;a<NE-4;a++) {
		x=nb_hasard(a);
#endif
		nbalea[a]=x;
	}

    for(nof=0;nof<2;nof++) { //nof= number of the bijection, 0=G, 1=G'
    	for(nor=0;nor<16;nor++) {//Only 16 functions for each bijection
            pos=nor%K;
            bloc=pos/NPM;
            place=pos%NPM;
         //Since we do not want to shift the data at the end et the rounds, we
         //calculate where we must put a mask (two bytes equal to zero)
         //This depend only of the round
            for(i=0;i<NA;i++) {//we will calculate g(i)
                for(part=0;part<NE;part++) {
#if (COMP==64)
                    x=nb_hasard(2*a);
#endif
#if (COMP==32)
                    x=nb_hasard(a);
#endif
                    if (part==bloc) {//For this word we must use a mask
                        x&=~((unsigned long int)(NA-1)<<((NPM-place-1)*NBE));
                    }
                    nbalea[a]=x;
                    a++;
                }
            }
        }
    }
}


int main()
{
   int a;

   init_alea();

#if (COMP==64)
    resultats=fopen("const_64.c","w");
    fprintf(resultats,"BlockType nbalea[2*16*256*16+16-2]={");
    for (a=0;a<2*NE*NA*16+NE-(128/COMP)-1;a++) {
            if ((a-NE+4)%8==0) fprintf(resultats,"\n");
            fprintf(resultats,"0x%llx, ",nbalea[a]);
    }
	fprintf(resultats,"0x%llx };\n",nbalea[a]);
    
#else

    resultats=fopen("const_32.c","w");
    fprintf(resultats,"BlockType nbalea[2*32*256*16+32-4]={");
    for (a=0;a<2*NE*NA*16+NE-(128/COMP)-1;a++) {
            if ((a-NE+4)%8==0) fprintf(resultats,"\n");
           fprintf(resultats,"0x%x, ",nbalea[a]);
    }
	fprintf(resultats,"0x%x };\n",nbalea[a]);
#endif
    fclose(resultats);
return 0;
}


